﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DrawEllipse
{
 


    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private MyPoint p1 = new MyPoint();
        private MyPoint p2 = new MyPoint();
        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            this.ptResult = new MyPoint[4];
            p1.X = e.X;
            p1.Y = e.Y;
        }

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            p2.X = e.X;
            p2.Y = e.Y;
            this.textBox1.Text = p1.ToString();
            this.textBox2.Text = p2.ToString();
            this.Invalidate();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            Graphics g = this.CreateGraphics();
            Pen pen = new Pen(Color.Red);
            g.DrawLine(pen, (float)p1.X, (float)p1.Y, (float)p2.X, (float)p2.Y);
            pen = new Pen(Color.Blue);
            if (ptResult != null && ptResult.Length == 4 && ptResult[0]!=null)
            {
                g.DrawLine(pen, (float)p1.X, (float)p1.Y, (float)ptResult[0].X, (float)ptResult[0].Y);
                g.DrawLine(pen, (float)p1.X, (float)p1.Y, (float)ptResult[1].X, (float)ptResult[1].Y);

                g.DrawLine(pen, (float)p2.X, (float)p2.Y, (float)ptResult[2].X, (float)ptResult[2].Y);
                g.DrawLine(pen, (float)p2.X, (float)p2.Y, (float)ptResult[3].X, (float)ptResult[3].Y);

            }
            base.OnPaint(e);
        }

        MyPoint[] ptResult = new MyPoint[4];
        private void btnCalc_Click(object sender, EventArgs e)
        {
            //const int size = 100;
            int size = Int32.Parse(this.txtSize.Text.Trim());
            p1 = new MyPoint(this.textBox1.Text.Trim());
            p2 = new MyPoint(this.textBox2.Text.Trim());
            MyPoint[] pts = Algorithm_PointPos(p1, p2, size);
            Graphics g = this.CreateGraphics();
            Pen p=new Pen(Color.Blue);
            this.Text = string.Empty;
            for (int i = 0; i < pts.Length; i++)
            {
                ptResult[i]=pts[i];
                this.Text += pts[i].ToString() + " | ";
            }
        }


        private MyPoint[] Algorithm_PointPos(MyPoint PointA, MyPoint pointB, int thick)
        {
            double h = thick / 2.0;
            MyPoint ptVec = new MyPoint();  //有符号
            ptVec.X = pointB.X - PointA.X;
            ptVec.Y = pointB.Y - PointA.Y;
            double lineLen = Math.Sqrt(Math.Pow(ptVec.X, 2) + Math.Pow(ptVec.Y, 2));
            double cosAngle = Math.Abs(ptVec.X) / lineLen;
            double sinAngle = Math.Abs(ptVec.Y) / lineLen;

            MyPoint ptAN = new MyPoint();   //first point
            ptAN.X = h * sinAngle;
            ptAN.Y = h * cosAngle;
            MyPoint[] pts = new MyPoint[4];
            if (ptVec.X * ptVec.Y > 0)
            {
                pts[0] = new MyPoint(PointA.X + ptAN.X, PointA.Y - ptAN.Y);
                pts[1] = new MyPoint(PointA.X - ptAN.X, PointA.Y + ptAN.Y);

                pts[2] = new MyPoint(pts[0].X + ptVec.X, pts[0].Y + ptVec.Y);
                pts[3] = new MyPoint(pts[1].X + ptVec.X, pts[1].Y + ptVec.Y);
            }
            else
            {
                pts[0] = new MyPoint(PointA.X - ptAN.X, PointA.Y - ptAN.Y);
                pts[1] = new MyPoint(PointA.X + ptAN.X, PointA.Y + ptAN.Y);

                pts[2] = new MyPoint(pts[0].X + ptVec.X, pts[0].Y + ptVec.Y);
                pts[3] = new MyPoint(pts[1].X + ptVec.X, pts[1].Y + ptVec.Y);
            }
            return pts;
        }

    }
    
    public class MyPoint
    {
        public MyPoint() { }
        public MyPoint(double x, double y) { this.X = x; this.Y = y; }
        public MyPoint(string str)
        {
            string [] sPart = str.Split(',');
            X = double.Parse(sPart[0]);
            Y = double.Parse(sPart[1]);
        }
        public double X { get; set; }
        public double Y { get; set; }
        public override string ToString()
        {
            return string.Format("{0:f2},{1:f2}",X,Y);
        }
    }
}
